#ifndef _ATALK_UTIL_H
#define _ATALK_UTIL_H 1

#include <sys/cdefs.h>
#include <sys/types.h>
#include <unistd.h>
#include <netatalk/at.h>

extern unsigned const char _diacasemap[], _dialowermap[];

extern char **getifacelist(void);
extern void freeifacelist(char **);


#define diatolower(x)     _dialowermap[(x)]
#define diatoupper(x)     _diacasemap[(x)]
extern int atalk_aton     __P((char *, struct at_addr *));
extern void bprint        __P((char *, int));
extern int strdiacasecmp  __P((const unsigned char *, const unsigned char *));
extern int strndiacasecmp __P((const unsigned char *, const unsigned char *,
			       int));
extern pid_t server_lock  __P((char * /*program*/, char * /*file*/, 
			       int /*debug*/));
#define server_unlock(x)  (unlink(x))

#ifdef NO_DLFCN_H
extern void *mod_open    __P((const char *));
extern void *mod_symbol  __P((void *, const char *));
extern void mod_close    __P((void *));
#define mod_error()      ""
#else
#include <dlfcn.h>
#ifndef RTLD_NOW
#define RTLD_NOW 1
#endif
#define mod_open(a)      dlopen(a, RTLD_NOW)
#ifndef DLSYM_PREPEND_UNDERSCORE
#define mod_symbol(a, b) dlsym(a, b)
#else
extern void *mod_symbol  __P((void *, const char *));
#endif
#define mod_error()      dlerror()
#define mod_close(a)     dlclose(a)
#endif

#endif
